/*********************************************/
/*       File name:  bb9reader.c             */
/*    Project name:  socket/daomon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "mylib.h"
#include "bb.h"

#define  SERV_NAME   "experiment"
#define  SERV_PROTO  "tcp"

extern void session(int soc);
static int setup(char *hostname);

main()
{
	int soc = -1;   /* å */
	char hostname[HOSTNAME_LENGTH];

	/* ФΥۥ̾ */
	printf("Input Server's Host Name: ");
	fgets(hostname, HOSTNAME_LENGTH, stdin);
	chop_newline(hostname, HOSTNAME_LENGTH);

	/* 饤ȤȤƤΥåȥå */
	if((soc = setup(hostname))<0){
		exit(1);
	}

	/* ӥ */
	session(soc);
}


static int setup(char *hostname)
	/* hostname ФΥۥ̾ */
{
	int soc;
	struct servent  *service_info;
	struct hostent  *host_info;
	struct sockaddr_in server;

	/* ӥץȥ̾ʤɤݡֹ */
	if((service_info = getservbyname(SERV_NAME, SERV_PROTO))==NULL){
		perror("getservbyname");
		return -1;
	}

	/* ۥ̾饵ФΥۥȤΥɥ쥹 */
	if((host_info = gethostbyname(hostname))==NULL){
		perror("gethostbyname");
		return -1;
	}

	/* ФΥɥ쥹 */
	memset((char *)&server, 0, sizeof(server));
	server.sin_family = AF_INET;
	server.sin_port = service_info->s_port;
	memcpy((char *)&server.sin_addr, host_info->h_addr,
	       host_info->h_length);

	/* åȤ */
	if((soc = socket(AF_INET, SOCK_STREAM, 0)) < 0){
		perror("socket");
		return -1;
	}

	/* ³ */
	if(connect(soc, (struct sockaddr *)&server, sizeof(server)) < 0){
		perror("connect");
		return -1;
	}
	fprintf(stderr, "connected\n");

	return soc;
}
