/*********************************************/
/*       File name:  service.c               */
/*    Project name:  socket/daemon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ӥ⥸塼 */

#include <fcntl.h>
#include "bb.h"

#define DATA_DIR "./data"
#define MENUSTRING "1.ƤӽФ  2.ٹ  3.  4.Ի  9.λ \n"


static int process(int soc, int item);

/* ؿ */
void service(int soc, char *myname)
	/* soc    å       */
	/* myname <-  argv[0]    */
{
	pid_t mypid;            /* ʬPID        */
	char buf[BUF_LENGTH];   /* Хåե   */
	int item;               /* ˥塼ֹ */

	mypid=(int)getpid();
	sprintf(buf, "This is %s[%d] serving you.\n",
	        myname, (int)mypid);
	write(soc, buf, strlen(buf));

	do{
		write(soc, MENUSTRING, strlen(MENUSTRING)); /* ˥塼 */
		read(soc, buf, 20);    /*  */
		sscanf(buf,"%d",&item);
	}
	while(process(soc, item));   /* ܽ */

	close(soc);
}

/* ץ饤١ȴؿ */
static int process(int soc, int item)
	/* soc   å         */
	/* item  ˥塼ֹ */
{
	int  fd; /* ǡեΤΥեǥץ */
	int  cnt;              /* ե뤫ɤ߽ФХȿ */
	char filename[FILENAME_LENGTH];      /* ǡե̾ */
	char buf[BUF_LENGTH];                /* ¿ŪХåե   */

	if(item==9)
		return 0;

	/* ǡե̾ưŪ */
	sprintf(filename, "%s/data%d", DATA_DIR, item);

	/* ǡեΥץ */
	if((fd=open(filename, O_RDONLY))==-1){
		write(soc, "invalid number.\n", 17);
		return 1;
	}

	/* ǡե򥽥åȤؽ񤭽Ф */
	while((cnt=read(fd, buf, BUF_LENGTH))!=0)
		write(soc, buf, cnt);

	/* ǡեΥ */
	close(fd);
	return 1;
}
