/*********************************************/
/*       File name:  setup_client.c          */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include "mylib.h"

int setup_client(char *hostname, in_port_t port)
	/*    åȤΥǥץ */
	/* hostname ³Υۥ̾         */
	/* port     ³Υݡֹ       */
{
	/* ѿ */
	struct hostent *server_ent; /* ³ΥۥȤξ       */
	struct sockaddr_in server;  /* ³ΥåȤΥɥ쥹 */
	int soc;                    /* ̿˻Ȥå         */

	/* ³Υۥ̾ۥȤξ */
	if((server_ent = gethostbyname(hostname)) == NULL){
		perror("gethostbyname");
		return -1;
	}

	/* ³Υɥ쥹 sockaddr_in ¤Τ */
	memset((char *)&server,0,sizeof(server));
	server.sin_family = AF_INET;
	server.sin_port = htons(port);
	memcpy((char *)&server.sin_addr, server_ent->h_addr,
	       server_ent->h_length);

	/* IPv4 ǥȥ꡼෿ΥåȤ */
	if ((soc = socket(AF_INET, SOCK_STREAM, 0)) < 0){
		perror("socket");
		return -1;
	}

	/* ³ */
	if (connect(soc,(struct sockaddr *)&server,sizeof(server)) == -1){
		perror("connect");
		return -1;
	}
	fprintf(stderr, "connected.\n");

	/* åȤ֤ */
	return soc;
}
