/*********************************************/
/*       File name:  setup_mserver,c         */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

int mserver_socket(in_port_t port, int backlog)
	/*    ԤåȤΥǥץ */
	/* port     ³Υݡֹ               */
	/* backlog  Ԥο                     */
{
	/* ѿ */
	struct sockaddr_in me; /* ʬΥåȤΥɥ쥹         */
	int soc_waiting;       /* ԤåȤΥǥץ */

	/* ʬΥɥ쥹 sockaddr_in ¤Τ */
	memset((char *)&me, 0, sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(port);

	/* IPv4 ǥȥ꡼෿ΥåȤκ */
	if ((soc_waiting = socket(AF_INET,SOCK_STREAM,0)) < 0 ){
		perror("socket");
		return -1;
	}

	/* åȤ˼ʬΥɥ쥹 */
	if (bind(soc_waiting,(struct sockaddr *)&me,sizeof(me)) == -1){
		perror("bind");
		return -1;
	}

	/* åȤ³Ԥ */
	if (listen(soc_waiting, backlog) == -1){
		perror("listen");
		return -1;
	}
	fprintf(stderr,"successfully setup, now waiting.\n");

	/* ԤѤΥǥץ֤ */
	return soc_waiting;
}

	/*  ޥץ  */

int mserver_maccept(int soc_waiting, int limit, void (*func)() )
	/*    ΥåȤΥǥץ      */
	/* soc_waiting   Ԥ˻Ȥå         */
	/* limit    accept ξ                       */
	/* func     accept ˼¹ԤؿؤΥݥ */
{
	int i;   /* 롼ץ */
	int fd;  /* ǥץѿ */

	/* accept  limit ¹ */
	for(i=0; i<limit; i++){
		if((fd = accept(soc_waiting, NULL, NULL))==-1){
			fprintf(stderr, "accept error\n");
			return -1;
		}
		(*func)(i, fd);
	}

	/* ԤΥåȤĤ */
	close(soc_waiting);

	/* Ǹ fd Ĥޤ֤ͤ */
	return fd;
}
