/*********************************************/
/*       File name:  setup_server.c          */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include "mylib.h"

int setup_server(in_port_t port)
	/*    åȤΥǥץ */
	/* port     ³Υݡֹ       */
{
	struct sockaddr_in me; /* ʬΥåȤΥɥ쥹 */
	int soc_waiting;       /* ³ԤΥå       */
	int soc;               /* ̿˻Ȥå       */

	/* ʬΥɥ쥹 sockaddr_in ¤Τ */
	memset((char *)&me, 0, sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(port);

	/* IPv4 ǥȥ꡼෿ΥåȤκ */
	if ((soc_waiting = socket(AF_INET,SOCK_STREAM,0)) < 0 ){
		perror("socket");
		return -1;
	}

	/* åȤ˼ʬΥɥ쥹 */
	if (bind(soc_waiting,(struct sockaddr *)&me,sizeof(me)) == -1){
		perror("bind");
		return -1;
	}

	/* åȤ³Ԥ */
	listen(soc_waiting,1);
	fprintf(stderr,"successfully bound, now waiting.\n");

	/* ³׵᤬ޤǥ֥å */
	soc = accept(soc_waiting, NULL, NULL);

	/* ³Ԥ˻ȤäåȤĤ */
	close(soc_waiting);

	/* ̿˻ȤåȤΥǥץ֤ */
	return soc;
}
