/*********************************************/
/*       File name:  setup_server6.c         */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include "mylib.h"
#define HOSTNAME_LENGTH 64

int setup_server(in_port_t port)
	/*    åȤΥǥץ */
	/* port     ³Υݡֹ       */
{
	struct addrinfo  hints; /* ʬˤĤΤäƤʬŪʾ    */
	struct addrinfo *res;   /* hints˴Ť̤γǼؤ */
	int soc_waiting;        /* ³ԤΥå                    */
	int soc;                /* ̿˻Ȥå                    */
	char portstring[8];     /* ݡֹνʸ                */
	char hostname[HOSTNAME_LENGTH];               /* ʬΥۥ̾  */

	/* ΥҥȤ */
	gethostname(hostname, HOSTNAME_LENGTH);
	sprintf(portstring, "%d", port);
	memset(&hints, 0, sizeof(struct addrinfo));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	/* ʬ˴ؤ򸡺 */
	if(getaddrinfo(hostname, portstring, &hints, &res) != 0){
		perror("getaddrinfo");
		return -1;
	}

	/* IPv4 ޤ IPv6ǥåȤκ */
	if((soc_waiting = socket(res->ai_family,
	   res->ai_socktype, res->ai_protocol)) < 0){
		perror("socket");
		return -1;
	}

	/* åȤ˼ʬΥɥ쥹 */
	if(bind(soc_waiting, res->ai_addr, res->ai_addrlen)!=0){
		perror("bind");
		return -1;
	}

	/* åȤ³Ԥ */
	listen(soc_waiting, 1);
	fprintf(stderr, "successfully bound, now waiting.\n");

	/* ³׵᤬ޤǥ֥å */
	soc = accept(soc_waiting, NULL, NULL);

	/* ³Ԥ˻ȤäåȤĤ */
	close(soc_waiting);

	/* ˻ȤäưŪβ */
	freeaddrinfo(res);

	/* ̿˻ȤåȤΥǥץ֤ */
	return soc;
}
