/*********************************************/
/*       File name:  server.c                */
/*    Project name:  socket/race             */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* 졼󥰥ΥХץ */

#include <stdio.h>
#include "race.h"
#include "mylib.h"
#include "sessionman.h"

main(int argc, char *argv[])
	/* argc     3Ǥäߤ */
	/* argv[1]  ץ졼οͿ  */
	/* argv[2]  ơ      */
{
	int num;              /* ץ졼οͿ    */
	int final;            /* ơο      */
	int soc_waiting;      /* listen ѥå */
	int maxfd;      /* åȤκΥǥץ */

	/* 3-1=2ĤǤäߤ */
	if(argc != 3){
		fprintf(stderr,"Usage: s players stages\n");
		exit(1);
	}

	/* Ѵ  ʸ --> int  */
	if(( num = atoi(argv[1]))<=0 || num > MAX_PLAYERS ){
		fprintf(stderr,"players limit= %d\n",MAX_PLAYERS);
		exit(1);
	}
	if(( final = atoi(argv[2]))<=0 || final > MAX_STAGES ){
	  fprintf(stderr,"stage limit= %d\n",MAX_STAGES);
	  exit(1);
	}

	/* ԤΤΥåȤκ */
	if((soc_waiting = mserver_socket(PORT, num))== -1){
	  fprintf(stderr,"cannot setup server\n");
	  exit(1);
	}

	/* maccept ˥Хåؿ enter Ϥ
	   ֤äΤϺΥǥץ */
	maxfd = mserver_maccept(soc_waiting, num, enter);

	/* å⥸塼ν */
	sessionman_init(num, final, maxfd);

	/* åΥᥤ롼 */
	sessionman_loop();
}
