/*********************************************/
/*       File name:  client.c                */
/*    Project name:  socket/1-1              */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORT     (in_port_t)50000 /* ()Υݡֹ */
#define BUF_LEN  512              /* ΥХåե礭 */

main()
{
	/* ѿ */
	struct hostent  *server_ent; /* ()ξ */
	struct sockaddr_in  server;  /* ()Υɥ쥹 */
	int soc;                     /* åȤΥǥץ */
	char hostname[]="cisprof08"; /* ()Υۥ̾ */
	char buf[BUF_LEN];           /* ΥХåե  */

	/* ()Υۥ̾饢ɥ쥹  */
	if((server_ent = gethostbyname(hostname)) == NULL){
		perror("gethostbyname");
		exit(1);
	}

	/* ()Υɥ쥹 sockaddr_in ¤Τ˳Ǽ  */
	memset((char *)&server, 0, sizeof(server));
	server.sin_family = AF_INET;
	server.sin_port = htons(PORT);
	memcpy((char *)&server.sin_addr, server_ent->h_addr,
	       server_ent->h_length);

	/* IPv4ǥȥ꡼෿ΥåȤ  */
	if((soc = socket(AF_INET, SOCK_STREAM, 0)) < 0){
		perror("socket");
		exit(1);
	}

	/* ()³  */
	if(connect(soc, (struct sockaddr *)&server, sizeof(server)) == -1){
		perror("connect");
		exit(1);
	}

	/* ꤬ */
	write(1, "Wait\n", 5);

	/* ̿Υ롼 */
	do{
		int n;                       /* ɤ߹ޤ줿Хȿ  */

		n = read(soc, buf, BUF_LEN); /* åsocɤ   */
		write(1, buf, n);            /* ɸ1˽񤭽Ф   */
		n = read(0, buf, BUF_LEN);   /* ɸ0ɤ     */
		write(soc, buf, n);          /* åsoc˽񤭽Ф */
	}
	while( strncmp(buf, "quit" ,4) != 0 );        /* λȽ */

	/* åȤĤ */
	close(soc);
}
