/*********************************************/
/*       File name:  bb.h                    */
/*    Project name:  socket/daemon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <stdio.h>
#include <netinet/in.h>

/* This definition is ingnored by bb9d and bb9reader */
#define PORT  (in_port_t) 50009

/* bb9 specific parameters are defined in bb9reader.c
   and in the system configuration files as described
   in the comment lines in bb9d.c                    */

/* Common parameters */
#define BUF_LENGTH         1024
#define HOSTNAME_LENGTH      64
#define FILENAME_LENGTH     128
