/*********************************************/
/*       File name:  bb0d.c                  */
/*    Project name:  socket/daemon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ΩƤʤǡ            */
/* ư bb0d & Τ褦ˤ롣      */
/* 饤Ȥ bbreader.c     */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <fcntl.h>

#include "bb.h"

extern void service(int soc,  char *myname);

main(int argc, char *argv[])
{
	struct sockaddr_in me;  /* ʬΥåȥɥ쥹 */
	int    soc_waiting;     /* Ԥѥå     */
	int    soc;             /* ӥѥå     */
	pid_t  pid;             /* ҥץPIDޤ0 */

	/* ʬΥɥ쥹sockaddr_in¤Τ */
	memset((char *)&me,  0,  sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(PORT);

	/* IPv4 ǥȥ꡼෿åȤ */
	if((soc_waiting = socket(AF_INET, SOCK_STREAM, 0)) < 0 ){
		perror("socket");
		exit(1);
	}

	/* ʬΥɥ쥹ΥåȤؤ */
	if(bind(soc_waiting, (struct sockaddr *)&me, sizeof(me)) == -1){
		perror("bind");
		exit(1);
	}

	/* ³ԤĹ */
	listen(soc_waiting, 5);
	fprintf(stderr, "successfully bound, now waiting.\n");

	/* 롼 */
	while(1){
		soc = accept(soc_waiting, NULL, NULL);

		if(( pid = fork() ) == (pid_t)0){
			/* ҥץ */
			close(soc_waiting);
			service(soc, argv[0]);
			exit(0);
		}    /* ҥץ */
		else {
			/* ƥץ soc 򥯥ƥ롼פ
			   Ƭˤɤ */
			close(soc);
			printf("My child [%d] now serving\n", (int)pid);
		}
	}
}
