/*********************************************/
/*       File name:  bb1d.c                  */
/*    Project name:  socket/daemon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ΥץüڤΥʪΥǡ */
/* 饤Ȥ bbreader.c                    */
/* λˤ kill ץID                     */
/* ps -ax | grep bb1d Ĵ٤                      */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <syslog.h>
#include <signal.h>
#include <fcntl.h>

#include "bb.h"

extern void service(int soc, char *myname);
static void ending(int);

main(int argc, char *argv[])
{
	struct sockaddr_in me;  /* ʬΥåȥɥ쥹 */
	int soc_waiting;        /* Ԥѥå     */
	int soc;                /* ӥѥå     */
	pid_t	pid;              /* ҥץPIDޤ0 */

	/* ǡȤƤμΩޤǤμ(1) */
	if(fork()!=0){
		exit(0);  /* 裱ץλ뤳Ȥ
		             ư椬롣
		             Ҥgroup leaderǤϤʤ */
	}

	/******* 裲ץ ********/

	/* ǡȤƤμΩޤǤμ(2) */
	setsid();     /* setsidؿˤꤳΥץϿ
	                 session leader group leader
	                 ˤʤ롣üϻʤ
	                 ʤgroup leaderˤsetsidؿ
	                 ¹ԤǤʤ*/
	if(fork()!=0){
		exit(0);    /* 裲ץλ롣
		               session leader ʤʤΤ
		               ʸü뤳ȤϤʤ */
	}

	/******* 裳ץ ********/

	/* ǡȤƤμΩޤǤμ(3) */
	chdir("/");    /* OSλȤ
	                  umountǤ򤫤ʤ */
	close(0); close(1); close(2); /* 뤫ѤǤ
				                     ǥץĤ */

	/*** ΩǤΤǡʸ塢裳ϿƤ򼫾Τ ***/

	signal(SIGTERM, ending);
	openlog(argv[0], LOG_PID, LOG_USER);

	/* ʬΥɥ쥹sockaddr_in¤Τ */
	memset((char *)&me, 0, sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(PORT);

	/* IPv4 ǥȥ꡼෿åȤ */
	if((soc_waiting = socket(AF_INET, SOCK_STREAM, 0)) < 0 ){
		syslog(LOG_ERR, "socket failed");
		exit(1);
	}

	/* ʬΥɥ쥹ΥåȤؤ */
	if(bind(soc_waiting, (struct sockaddr *)&me, sizeof(me)) == -1){
		syslog(LOG_ERR, "bind failed");
		exit(1);
	}

	/* ³ԤĹ */
	listen(soc_waiting, 5);
	syslog(LOG_ERR, "listen succeeded");

	/* 롼 */
	while(1){
		soc = accept(soc_waiting, NULL, NULL);

		if(( pid = fork() ) == (pid_t)0){
			/* ҥץ */
			close(soc_waiting);
			service(soc, argv[0]);
			exit(0);
		}    /* ҥץ */
		else
			/* ƥץ soc 򥯥ƥ롼פ
			   Ƭˤɤ */
			close(soc);
		syslog(LOG_ERR, "My child [%d] now serving", (int)pid);
	}
}


static void ending(int dummy){
	syslog(LOG_ERR, "service terminated");
	closelog();
	exit(0);
}
