/*********************************************/
/*       File name:  sessionman.c            */
/*    Project name:  socket/mtalk            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ߥŻҲĤΥåץ */

#include <stdio.h>
#include <sys/types.h>

#define	MAX_ATTENDANTS 5
#define BUF_LEN	     80


static  char    buf[BUF_LEN];  /* Хåե           */
static  fd_set  mask;	     /* selectѽޥ     */
static  int     width;         /* ƻǥץϰ */
static  int     attendants;    /* üԿͿ               */

/* üԴΤΥǡ¤ */
typedef	struct{
	int   fd;
	char  name[16];
} ATTENDANT;

static ATTENDANT p[MAX_ATTENDANTS]; /* üԾ */

/*  session Υᥤ롼פβ롼 */
static void send_all(int i, int n);
static void ending();

/*  enter  mserver_maccept() Ϥ륳Хåؿ */
void enter(int i, int fd)
	/* i   ֹ                 */
	/* fd  ˻Ѥ륽å */
{
	int	len;   /* Хȿ */
	static char *mesg1="Type your name.\n";
	static char *mesg2="Wait.\n";

	p[i].fd = fd;
	memset(p[i].name,0,16);
	write(fd, mesg1, strlen(mesg1));
	len = read(fd, p[i].name, 16);
	sprintf(p[i].name + len - 1, "  -->  ");
	write(fd, mesg2, strlen(mesg2));
}


/*  åν */
void sessionman_init(int num, int maxfd)
	/* num    attendants οͿ    */
	/* maxfd  Υǥץ */
{
	int i;                /* 롼ץ */
	static char *mesg="Communication Ready.\n";
	attendants = num;     /* üԿͿ */

	/* select ΤΥޥ  */
	width = maxfd + 1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	for (i=0; i<num; i++){
		FD_SET(p[i].fd , &mask);
	}

	/* å󳫻ϤΥå */
	for (i=0; i<num; i++)
		write(p[i].fd, mesg, strlen(mesg));
}

/*  åΥᥤ롼  */
void sessionman_loop()
{
	fd_set readOk;     /* selectΤΥޥ */
	int i;             /* 롼ץ       */

	while(1){
		/*  select  readOk  */
		readOk = mask;
		select(width,(fd_set *)&readOk,NULL,NULL,NULL);

		/*  ܡɤϤ꤫ */
		if ( FD_ISSET(0, &readOk ) )
			ending();

		/* åȤĴ٤ */
		for( i=0; i<attendants; i++){
			if(FD_ISSET(p[i].fd, &readOk)){
				int	n;

				n=read(p[i].fd,buf,BUF_LEN);
				send_all(i, n);
			}
		}
	}
}


/************************************/
/*  ᥤ롼פβ롼ã  */
/************************************/

/* λ */
static void ending()
{
	int	i;

	for (i=0; i<attendants; i++)
		write(p[i].fd, "q", 1);
	for( i=0; i<attendants; i++)
		close(p[i].fd);
	exit(0);
}

static void send_all(int i, int n)
     /* i  p[i] ̾դ */
     /* n  Хȿ        */
{
	int  j;

	for(j=0; j<attendants; j++){
		write(p[j].fd, p[i].name, strlen(p[i].name));
		write(p[j].fd, buf, n);
	}
}
