/*********************************************/
/*       File name:  setup_mserver6.c        */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define HOSTNAME_LENGTH 64

int mserver_socket(in_port_t port, int backlog)
	/*    ԤåȤΥǥץ */
	/* port     ³Υݡֹ               */
	/* backlog  Ԥο                     */
{
	/* ѿ */
	struct addrinfo  hints; /* ʬˤĤΤäƤʬŪʾ    */
	struct addrinfo *res;   /* hints˴Ť̤γǼؤ */
	int soc_waiting;        /* ³ԤΥå                    */
	char portstring[8];     /* ݡֹ10ʸ                */
	char hostname[HOSTNAME_LENGTH];               /* ʬΥۥ̾  */

	/* ΥҥȤ */
	gethostname(hostname, HOSTNAME_LENGTH);
	sprintf(portstring, "%d", port);
	memset(&hints, 0, sizeof(struct addrinfo));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	/* ʬ˴ؤ򸡺 */
	if(getaddrinfo(hostname, portstring, &hints, &res) != 0){
		perror("getaddrinfo");
		return -1;
	}

	/* IPv4 ޤ IPv6 ǥåȤκ */
	if((soc_waiting = socket(res->ai_family,
	   res->ai_socktype, res->ai_protocol)) < 0){
		perror("socket");
		return -1;
	}

	/* åȤ˼ʬΥɥ쥹 */
	if(bind(soc_waiting, res->ai_addr, res->ai_addrlen)!=0){
		perror("bind");
		return -1;
	}

	/* åȤ³Ԥ */
	if (listen(soc_waiting, backlog) == -1){
		perror("listen");
		return -1;
	}
	fprintf(stderr,"successfully setup, now waiting.\n");

	/* ǻȤäưŪ */
	freeaddrinfo(res);

	/* ԤѤΥǥץ֤ */
	return soc_waiting;
}

/*  ޥץ  */

int mserver_maccept(int soc_waiting, int limit, void (*func)() )
	/*    ΥåȤΥǥץ      */
	/* soc_waiting   Ԥ˻Ȥå         */
	/* limit    accept ξ                       */
	/* func     accept ˼¹ԤؿؤΥݥ */
{
	int i;   /* 롼ץ */
	int fd;  /* ǥץѿ */

	/* accept  limit ¹ */
	for(i=0; i<limit; i++){
		if((fd = accept(soc_waiting, NULL, NULL))==-1){
			fprintf(stderr, "accept error\n");
			return -1;
		}
		(*func)(i, fd);
	}

	/* ԤΥåȤĤ */
	close(soc_waiting);

	/* Ǹ fd Ĥޤ֤ͤ */
	return fd;
}
