/*********************************************/
/*       File name:  sessionman.c            */
/*    Project name:  socket/race             */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/*  sessionman.c                   */
/*   졼Υåޥ͡  */

#include <stdio.h>
#include <sys/types.h>
#include "race.h"

#define MAX_DAMAGE 10

static	int soc[MAX_PLAYERS];              /* åȤ */
static	char name[MAX_PLAYERS][16];        /* ץ졼̾ */
static  char p[MAX_PLAYERS * PLAYER_SIZE]; /* ץ졼ξ */

static  fd_set  mask;   /* selectνѥޥ */
static  fd_set  readOk; /* selectη           */
static  int     width;  /* ƻǥץ */

static  int final;    /* ǽơ     */
static  int num;      /* üԿ         */
static  int reached;  /* 륤󤷤 */
static  int crashed;  /* å夷 */

/* ɽ */
static  char g[MAX_PLAYERS * GRADE_SIZE];

/* ᥤ롼פβ롼 */
static  void	recv_data();
static  void	send_data();
static  void	ending();


/*  enter  maccept() Ϥ륳Хåؿ */
void enter(int i, int fd)
	/* i   ȥֹ  */
	/* fd  å      */
{
	int    len;
	static char *login_mesg="Your name?";
	char   mesg[32];

	soc[i] = fd;
	write(soc[i],login_mesg,11);
	read(soc[i], name[i],16);

	/* entry number  */
	sprintf(mesg, "%d\n", i);
	write(soc[i], mesg, strlen(mesg) + 1);
	printf("[%d] %s\n", i, name[i]);
}


/*  åν */
void sessionman_init(int n, int fin, int maxfd)
	/*   n      üԤοͿ         */
	/*   fin    ơ           */
	/*   maxfd  Υǥץ */
{
	int i;
	static char mesg[10];

	num = n;
	final = fin;

	/* select ΤΥޥ  */
	width = maxfd + 1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	for (i=0; i<num; i++)
		FD_SET(soc[i] , &mask);

	/* å󳫻ϤΥǡ */
	sprintf(mesg, "%d %d\n", num, final);
	for (i=0; i<num; i++)
		write(soc[i], mesg, 10);
	reached = 0;
	crashed = 0;
}

/* åΥᥤ롼  */
void sessionman_loop()
{
	while(reached + crashed < num){
		recv_data();
		send_data();
	}
	ending();
}


/************************/
/*  level 2 δؿ  */
/************************/

/* ǽʤ٤ƤΥǥץɤ */
static void recv_data()
{
	int	i;

	readOk = mask;  /* ޥ */
	select(width, &readOk, NULL, NULL, NULL);

	for(i=0; i<num; i++){
		if(FD_ISSET(soc[i],(fd_set *)&readOk)){

			/* iܤΥץ졼i*PLAYER_SIZEեå
			 pξ˥ǡ򥳥ԡ롣ԡ PLAYER_SIZE */
			read(soc[i], &p[i * PLAYER_SIZE], PLAYER_SIZE);

			/* ᡼Υå */
			if(p[i * PLAYER_SIZE + DAMAGE] >= MAX_DAMAGE){
				g[(num-crashed-1) * GRADE_SIZE + ENTRYNUM] = i;
				strcpy(&g[(num-crashed-1)*GRADE_SIZE + ENTRYNAME] , name[i]);
				crashed++;
			}
			/* 륤Υå */
			if(p[i * PLAYER_SIZE + STAGE] > final){
				g[reached * GRADE_SIZE + ENTRYNUM] = (char)i;
				strcpy(&g[reached * GRADE_SIZE + ENTRYNAME], name[i]);
				reached++;
			}

		}
	}
}


/* ٤ƤΥǡۿ */
static void send_data()
{
	int	i;

	for (i=0; i<num; i++){
		if ( FD_ISSET(soc[i],&readOk ))
			write(soc[i], p, PLAYER_SIZE * num );
	}
}

/* λ */
static void ending()
{
	int	i;

	for (i=0;i<num;i++)
		write(soc[i], g, GRADE_SIZE * num);

}
